



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>利用子集构造法实现NFA到DFA的转换</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">利用子集构造法实现NFA到DFA的转换</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-05 00:29:49 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<ul><li><h1>概述</h1></li></ul>
<p>NFA非有穷自动机，即当前状态识别某个转换条件后到达的后继状态不唯一，这种自动机不便机械实现，而DFA是确定有限状态的自动机，它的状态转换的条件是确定的，且状态数目往往少于NFA，所以DFA能够比较方便的机械实现且识别能力方面也和NFA相当。本次实验采用子集构造法来实现不带空弧的由NFA到DFA的转换。</p>
<p>子集构造法的算法如下：</p>
<p>设NFA为M=(K,&Sigma;,f,S0,Z)，则构造相应的DFA&nbsp;&nbsp;M&prime;=(Q,&Sigma;,f&prime;,I0,F)<br />①取I0=S0；<br />②对于状态集Q中任一尚未标记的状态qi={Si1,Si2,&hellip;,Sim},Sik&isin;K，做：<br />&nbsp;(1)&nbsp;标记qi；<br />&nbsp;(2)&nbsp;对于每个a&isin;&Sigma;，置<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;T=f({Si1,Si2,&hellip;,Sim},a)<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;qj=&epsilon;CLOSURE(T)<br />&nbsp;(3)&nbsp;若qj不在Q中，则将qj作为一个未加标记的状态添加到Q中，且把状态转移f&prime;(qi,a)=qj添加到M&prime;。<br />③重复进行步骤②，直到Q中不再含有未标记的状态为止。对于由此构造的Q，我们把那些至少含有一个Z中的元素的qi作为M&prime;的终态。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1019361/201704/1019361-20170429212108115-2113207707.png" /></p>
<p>对于如图所示的NFA其在文件中保存的信息如下</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1019361/201704/1019361-20170429212148303-719076702.png" /></p>
<p>转成DFA之后的形式为</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1019361/201704/1019361-20170429212224412-1523090839.png" /></p>
<p>重命名为</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1019361/201704/1019361-20170429212253756-1913169550.png" /></p>
<ul><li><h1>程序整体思路</h1></li></ul>
<p>首先将文件中所给的NFA输入读入程序，在读入过程中将其以图的邻接表的形式保存，其中将状态转移条件记为该边的权值，每种状态记为图的结点，该状态识别状态转移条件(权值)之后到达的状态为该结点的邻接点。</p>
<p>对于上面的例子，将其读入程序中后该图在程序中的逻辑存储结构（图的邻接表）如图所示，其中邻接点中第一个数字表示权值，第二个数字表示所连的结点。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1019361/201704/1019361-20170429212334725-314105066.png" /></p>
<p>将图读入程序中后，再使用子集构造算法来完成由NFA到DFA的转化。</p>
<p>对于每种状态，其数据结构定义为</p>
<div>
<div>
<pre class="prettyprint linenums"> typedef struct state<br />
 {<br />
     set&lt;int&gt; Set;<br />
     char name;<br />
 }state;</pre>
</div>
</div>
<p>其中set里存放该状态识别某个条件后所能到达的状态集合的下标，name里存该状态重命名后的名字。</p>
<p>这些状态保存在状态数组States[max]中，状态数组States[max]数据结构定义为</p>
<div>
<div>
<pre class="prettyprint linenums"> state States[max];</pre>
</div>
</div>
<p>子集构造法的过程就是不断向状态数组States[&nbsp;]中，添加识别某个条件后，新的未出现的状态的过程。</p>
<p>程序中函数说明</p>
<p>void&nbsp;creatph(algraph&nbsp;&amp;g,FILE&nbsp;*fpr)：将文件内容读入程序，并将其转换为图的邻接表子函数。</p>
<p>int&nbsp;change(algraph&nbsp;g,char&nbsp;p)：将图中结点转化为对应下标子函数。</p>
<p>state&nbsp;move(state&nbsp;s,int&nbsp;n,algraph&nbsp;g)：求当前状态集合的转移集合，即求s状态识别字母n之后的状态集合。</p>
<p>int&nbsp;equalSet(state&nbsp;m,state&nbsp;n)：比较两个状态的set集合内容是否相等，不相等返回0，相等返回1。</p>
<p>void&nbsp;inStates(state&nbsp;&amp;s)：判断当前状态是否在States数组中存在，若存在，进行改名；若不存在，改名后加入States数组。</p>
<p>void&nbsp;changeToD(algraph&nbsp;g,FILE&nbsp;*fpw)：由NFA转到DFA的主控程序子函数。</p>
<p>程序输入如下图所示</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1019361/201704/1019361-20170429213849319-1964054493.png" /></p>
<p>程序输出如下图所示</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1019361/201704/1019361-20170429213942272-1789239834.png" /></p>
<ul><li><h1>代码清单</h1></li></ul>
<div>
<div>
<pre class="prettyprint linenums"> #include&lt;stdio.h&gt;<br />
 #include&lt;malloc.h&gt;<br />
 #include &lt;iostream&gt;<br />
 #include &lt;fstream&gt;<br />
 #include &lt;cstring&gt;<br />
 #include&lt;set&gt;

 using namespace std;

 #define max 50//定义结点最大数量<br />
 typedef char vertype;//定义结点值域为字符类型<br />
 char buf[];//定义读文件内容时，程序缓冲数组<br />
 int num;//记录有穷字母表元素的个数<br />
 int length;//记录States数组的长度

 typedef struct arcnode//图的边信息<br />
 {<br />
     int adjvex;<br />
     int weight;//边所对应的权值<br />
     struct arcnode *next;<br />
 }arcnode;

 typedef struct vnode//图的结点类型定义<br />
 {<br />
     vertype data;<br />
     arcnode *next;<br />
 }vnode,adjlist[max];

 typedef struct//图的定义<br />
 {<br />
     adjlist a;<br />
     int vexnum,arcnum;<br />
 }algraph;

 typedef struct state//状态的定义<br />
 {<br />
     set&lt;int&gt; Set;<br />
     char name;<br />
 }state;

 state States[max];

 int change(algraph g,char p)//将图中结点转化为对应下标<br />
 {<br />
     int i;<br />
     for(i=;i&lt;g.vexnum;i++)<br />
     {<br />
         if(p==g.a[i].data)<br />
             return i;<br />
     }<br />
     return -;<br />
 }

 void creatph(algraph &amp;g,FILE *fpr)<br />
 {<br />
     int line = ;<br />
     while(!feof(fpr))<br />
     {<br />
         fgets(buf,,fpr);<br />
         if(strlen(buf)&gt;)//获取文件中图的结点个数<br />
         {<br />
             int i = ;<br />
             while(buf[i]==' ')<br />
             {<br />
                 i++;<br />
             }

             g.a[line].data=buf[i];<br />
             g.a[line].next=NULL;<br />
             line++;<br />
         }<br />
     }<br />
     g.vexnum=line;

     rewind(fpr);//将文件指针返回到开头位置<br />
     line = ;<br />
         arcnode *s;

     while(!feof(fpr))//再次扫描文件将边的信息添上，构造图<br />
     {<br />
         int weight=;//边所对应的权值,每一行权值都从0开始<br />
         fgets(buf,,fpr);<br />
         if(strlen(buf)&gt;)<br />
         {<br />
             for(int i=;i&lt;strlen(buf)-;i++)<br />
             {<br />
                 if(buf[i]=='{')<br />
                 {<br />
                     weight++;<br />
                     if(num&lt;weight)<br />
                         num=weight;

                     i++;<br />
                     if(buf[i]=='N')<br />
                             i=i+;

                     while(buf[i]!='}')<br />
                     {<br />
                         if(buf[i]!=',')<br />
                         {<br />
                             //cout&lt;&lt;buf[i];////////////////////////////////<br />
                             int x = change(g,buf[i]);

                             s=(arcnode *)malloc(sizeof(arcnode));<br />
                             s-&gt;adjvex=x;<br />
                             s-&gt;weight=weight;<br />
                             s-&gt;next=g.a[line].next;<br />
                             g.a[line].next=s;<br />
                             //cout&lt;&lt;line;////////////////////////////////<br />
                         }<br />
                         i++;<br />
                     }<br />
                 }<br />
             }<br />
             line++;<br />
         }<br />
     }

 }

 state move(state s,int n,algraph g)//求当前状态集合的转移集合，即求s状态识别字母n之后的状态集合<br />
 {<br />
     state temp;<br />
     arcnode *m;<br />
     set&lt;int&gt;::iterator itr;//迭代器<br />
     for(itr = s.Set.begin();itr!=s.Set.end();itr++)//遍历当前s状态中集合元素<br />
     {<br />
         int i = *itr;<br />
         m = g.a[i].next;<br />
         while(m)<br />
         {<br />
             if(m-&gt;weight==n)<br />
             {<br />
                 temp.Set.insert(m-&gt;adjvex);//cout&lt;&lt;m-&gt;adjvex&lt;&lt;" ";<br />
             //    temp.name=s.name+1;//cout&lt;&lt;temp.name&lt;&lt;endl;<br />
             }<br />
             m=m-&gt;next;<br />
         }<br />
     }<br />
     return temp;<br />
 }

 int equalSet(state m,state n)//比较两个状态的set集合内容是否相等<br />
 {<br />
     int flag = ;<br />
     if(m.Set.size()!=n.Set.size())<br />
     {<br />
         flag = ;<br />
         return flag;<br />
     }

     set&lt;int&gt;::iterator itrm;<br />
     set&lt;int&gt;::iterator itrn;<br />
     for(itrm = m.Set.begin(),itrn = n.Set.begin();itrm!=m.Set.end();itrm++,itrn++)<br />
     {<br />
         int m = *itrm;<br />
         int n = *itrn;

         if(m!=n)<br />
         {<br />
             flag = ;<br />
             break;<br />
         }<br />
     }<br />
     return flag;<br />
 }

 void inStates(state &amp;s)//判断当前状态是否在States数组中存在，若存在，进行改名；若不存在，改名后加入States数组<br />
 {<br />
     int flag = ;<br />
     if(length==)<br />
     {<br />
         States[]=s;<br />
         States[].name='A';<br />
         length++;<br />
     }<br />
     else<br />
     {<br />
         for(int i=;i&lt;length;i++)<br />
         {<br />
             //cout&lt;&lt;equalSet(States[i],s);<br />
             if(equalSet(States[i],s)==)//若存在，进行改名<br />
             {<br />
                 s.name=States[i].name;<br />
                 flag = ;<br />
                 break;<br />
             }<br />
         }

         if(flag == )//若不存在，改名后加入States数组<br />
         {<br />
             s.name=States[length-].name+;<br />
             States[length]=s;<br />
             length++;<br />
         }<br />
     }<br />
 }

 void changeToD(algraph g,FILE *fpw)<br />
 {<br />
     state s,temp;<br />
     s.Set.insert();<br />
     s.name='A';

     inStates(s);

     for(int i=;i&lt;length;i++)<br />
     {<br />
         cout&lt;&lt;"{";<br />
         fprintf(fpw,"{");

         set&lt;int&gt;::iterator itr;//迭代器<br />
         for(itr = States[i].Set.begin();itr!=States[i].Set.end();itr++)//遍历当前s状态中集合元素<br />
         {<br />
             int i = *itr;<br />
             cout&lt;&lt;g.a[i].data&lt;&lt;",";<br />
             fprintf(fpw,"%c,",g.a[i].data);<br />
         }

         cout&lt;&lt;"}";<br />
         fprintf(fpw,"}");

         cout&lt;&lt;States[i].name;<br />
         fprintf(fpw,"%c",States[i].name);

         for(int j=;j&lt;=num;j++)<br />
         {<br />
             temp = move(States[i],j,g);<br />
             inStates(temp);<br />
             //查看temp状态的set集合<br />
             /*<br />
             set&lt;int&gt;::iterator itr;//迭代器<br />
             for(itr = temp.Set.begin();itr!=temp.Set.end();itr++)//遍历当前s状态中集合元素<br />
             {<br />
                 int i = *itr;<br />
                 cout&lt;&lt;i&lt;&lt;" ";<br />
             }*/<br />
             cout&lt;&lt;temp.name;<br />
             fprintf(fpw,"%c",temp.name);<br />
         }<br />
         cout&lt;&lt;endl;<br />
         fprintf(fpw,"\n");<br />
     }<br />
 }

 int main()<br />
 {<br />
     algraph g;

     FILE *fpr = fopen("F:\\test.txt","r");<br />
     FILE *fpw = fopen("F:\\testOutput.txt","w");

 /*    FILE *fpr = fopen("test.txt","r");<br />
     FILE *fpw = fopen("output.txt","w");*/

     creatph(g,fpr);

     //create测试<br />
     /*<br />
     for(int i=0;i&lt;g.vexnum;i++)<br />
     {<br />
         cout&lt;&lt;g.a[i].data&lt;&lt;endl;//////////////////

     }<br />
     */

     changeToD(g,fpw);<br />
     //move测试<br />
     /*<br />
     state s;<br />
     s.Set.insert(0);<br />
     s.Set.insert(2);<br />
     s.Set.insert(3);<br />
     s.mark=1;<br />
     s.name='B';

     move(s,2,g);<br />
     */<br />
     return ;<br />
 }</pre>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390ryrj9.html">&period;Net批量插入数据到SQLServer数据库&comma;System&period;Data&period;SqlClient&period;SqlBulkCopy类批量插入大数据到数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdogxj8.html">JS添加父节点的方法。</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnry329.html">The world beyond batch&colon; Streaming 101</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1gdd2q.html">【Android测试】【随笔】搜狗、腾讯技术交流会心得</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p1z579.html">ASM磁盘组兼容性设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvveno1q.html">Python脚本控制的WebDriver 常用操作 &amp;lt&semi;八&amp;gt&semi; 简单的对象定位</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn14zx28.html">HW6&period;18</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvpn6xq.html">Java  对象属性的遍历</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok6yvx9.html">Flask&plus;Mysql搭建网站之数据库问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oxxry9.html">定制化Azure站点Java运行环境&lpar;4&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljkp2k9.html">background相关属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpvdkj9.html">使用Git上传项目代码到github</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me5dx6q.html">java中&OpenCurlyDoubleQuote;&equals;&equals;&rdquo;和equals方法的区别，再加上特殊的String引用类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z0l5n9.html">PowerEdge R430 机架式服务器安装&lpar; Ubuntu server 14&period;04&period;1 、PHP5&period;5&period;9、PHP-redis2&period;8、Phalcon3&period;1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgor1e8.html">Web从入门到放弃&amp;lt&semi;4&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gel7pz8.html">Oracle 数据文件迁移</a>
		</li>
						<li><a href="https://www.batexi.com/a/9600ow39.html">JavaScript基础视频教程总结（071-080章）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwz2ox9.html">阿里云-CDN</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r1kk39.html">【读书笔记】iOS-UDID</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv0nv28.html">使用jdom进行xml解析，网络抓包</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93ynklg8.html">利用python的爬虫技术爬去糗事百科的段子</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j0ndv8.html">【好记性不如烂笔头】死锁之java代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1rl1mq.html">C&plus;&plus;11右值引用和std&colon;&colon;move语句实例解析</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mendj8.html">Java：从面试题&OpenCurlyDoubleQuote;i&plus;&plus;和&plus;&plus;i哪个效率高？&amp;quot&semi;开始学习java字节码</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzp6n48.html">linux之date命令详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv10pgoq.html">ActiveMQ Part 1 &colon; 基本安装配置（windows 版本）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kjxv49.html">串的模式匹配和KMP算法</a>
			</li>
						<li><a href="https://www.batexi.com/a/90me3ro8.html">Adobe 系列软件通用破解方式（animate cc&comma;Photoshop cc&comma;Flash cc）等</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ynzpz8.html">玩转SSH（四）：Struts &plus; Spring &plus; MyBatis</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzp3el8.html">Java并发编程：volatile 关键字</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
